Opening Display

The opening view displays the names of the error files of the current workspace. The screen is divided into the following areas: the Error file panel on the left, the Error messages panel on the right, and finally the status bar on the bottom. Each of these areas are discussed in their own section.


Error Files

The above screenshot shows all possible error files of Visual DataFlex. User errors are stored in the first file called FLEXERRS.DAT and you may use the error number starting at 120. You can add a maximum of 3976 errors. Error numbers are assigned in sequential order; there cannot be a gap in the error number.

Visual DataFlex supports the Btrieve (Pervasive Software) data format. This database system has—like DataFlex—a number of error codes that are mapped by the Data Access Btrieve driver to the error number in DFERR005.DAT file.

User

The User errors are stored in FLEXERRS.DAT and run from 120-4096. The first 120 error numbers are DataFlex errors present from the history.

System

The System errors are stored in DFERR001.DAT and run from 4096 to 8191. These error numbers cover among others, the DataFlex Server Edition and DBMS-API errors.

Utility

The Utility errors are stored in DFERR002.DAT and run from 8193 to 12287. These errors are used by the DataFlex utilities/tools.

DBMS Drivers

The DBMS driver errors are stored in DFERR003.DAT. The range of these errors start at 12289 and end at 16383. The ODBC driver errors are located in this file.

Reserved

The Reserved errors are stored in DFERR004, DFERR006 and DFERR007. These blocks of error numbers are reserved for the future.


Error Messages

The above grid displays the complete contents of the selected error file whose name is noted in the status bar. Users can browse through the records and translate the description/note of the error. Records can only be added in the FLEXERRS.DAT file using error numbers from 120 through 4096. Error numbers below 120 or higher than 4096 cannot be deleted via the Maintenance program.

Error#

This column shows the error number. Errors in a file (FLEXERRS.DAT, DFERR00N.DAT) are record numbers. The number in this column is adjusted with an offset (see "Overview ")

Description

The error description is a 40 character maximum field which contains the text of the error. This description can be translated by the developer.

Note

The error note usually contains a hint about how to solve the error (using DataFlex) or who caused the error (program/operator).

Creating Errornumber Block

A right click on the mouse when it is in the Error messages panel will allow you to choose the "Create errors" option from a pulldown. This option will bring up the "Errornumber to generate" dialog box. This option is only available when the current error file is Flexerrs.Dat itself and the DbAdminMode has been set to either ON or DDB.

This option is present to give you the opportunity to start with numbering at a different location. It will fill the gap between the last used error number and the first number you want to start with.

Enter the amount of error numbers to be generated and press [Alt+O] or click the Ok Button. A progress bar will appear in the status bar showing the progress of record creation. When you enter an amount less than or equal to zero or an amount which would create more than 4096 errors in the Flexerrs datafile, the following error appears:


Status Bar

The status bar displays the current error file. It is the physical name (path + filename) of the error file.


Menu Bar

The menu bar of the Flexerrs Maintenance program contains the following popup menus: File, Record, Window, and Help.


File Popup Menu

The File popup menu shows the file related topics of the Flexerrs Maintenance program.

Select Workspace

Though not used often, a set of error files can be setup per workspace. The User errors file will be a good candidate for this. If you have made separate error files per workspace, a new workspace can be selected via this panel. Selecting a new workspace is also available via the ‘new workspace’ button [image] on the tool bar.

Current Workspace

This area shows the current workspace (according to the Windows registry). If you started Flexerrs with the name of a workspace as a first command line argument, the workspace name will not be listed.

Available Workspaces

This area shows all available workspaces in your environment. Workspaces are stored in the Windows registry.

Select

This button will allow you to select another workspace (also stored in the Windows registry.

Cancel

This button will close the Workspace Manager panel without making a change.

Options

The Options dialog box is only accessible when the DbAdminMode setting of the Visual DataFlex branch in the Windows registry is set to either ON or DDB.

Confirm questions

When the "Confirm questions" option is checked, "Yes/No" dialog boxes confirming the action will appear when you are about to save changes, delete records, or run into data loss.

Errorfiles-tree timer

This value will be used by the Flexerrs Maintenance program in the list of error files when you navigate with cursor keys through the list. The default value is 500 milliseconds. When an item becomes current for more than this amount of time, the action behind the item will be executed.

Current row color

By setting this option, the RGB color to use in the Error messages panel for the current row is defined. Press the prompt key [F4] or click the prompt button to select a color via the Windows ChooseColor dialog. The chosen value will be stored in the Windows registry under the CurrentRowColor entry.

Current item color

By setting this option, the RGB color to use in the Error messages panel for the current item in the current row is defined. Press the prompt key [F4] or click the prompt button to select a color via the Windows ChooseColor dialog. The chosen value will be stored in the Windows registry under the CurrentItemColor entry.

Save

This button closes the Options panel and saves the selected options to the Windows Registry.

Apply

This button displays the results of the current settings selected in the Options dialog as well as saving them to the Windows Registry.

Close

This button closes the Options panel without saving the options selected to the Windows Registry.

Exit

This choice (or the key [Alt+F4] combination) will terminate the Flexerrs Maintenance program.


Record Popup Menu

The actions of the Record pulldown will become available as soon as the cursor is present in the Error# grid. Some actions (delete, save, and the find options) are only accessible under certain circumstances.


Window Popup Menu

The Window popup menu of Flexerrs Maintenance program allows you to toggle the display of the toolbar and status bar. The choices are stored in the Windows registry under the names, StatusBarVisibleState and ToolBarVisibleState. The values are stored as dWord value.


Help Popup Menu

The Help popup menu displays the following help choices of the Flexerrs Maintenance program:

Context Help

This item will bring up the Flexerrs help file and displays a help topic specific to the location of your cursor in the Flexerrs Maintenance program.

Files Help

The errors system of DataFlex uses several datafiles to store the error number in.

Keys Help

This help item shows the available keys in the Flexerrs Maintenance program.

All underlined characters (in the menubar, pulldowns checkboxes, and buttons) are accessible via the Alt+ (underlined character) combination.

Key | Where | Action
F2 | Error messages panel | Save row
F5 | Error messages panel | Clear changes
F11 | Error messages panel | Insert new row
Ctrl+Home | Error messages panel | Begin of error file
Ctrl+End | Error messages panel | End of error file
F9 | Errorgrid | Finds in error file
Alt+O | Create errors panel | Start creating errors
Alt+F | Create errors panel | Close the panel
Alt+O | About panel | Open System Information panel
Alt+C | About panel | Close About panel
Alt+F4 | Almost everywhere | Close panel or program

Index Help

This item will display the last tab page (ex. Contents, Index, or Find tab pages) viewed in the Flexerrs help file.

Search for Help on...

This item on the Help pulldown displays the Find tab page in the Flexerrs help file where you can perform a search on keywords/topics.

How to Use Help

This item will display the Windows help file which explains how to use Windows help.

About

The About panel contains information about the Flexerrs Maintenance program and the environment it is being run in. This panel contains the name of program (Flexerrs Maintenance), the revision number, copyright information, and the name of the developer.

System Info

The System Information panel displays the following information:

Username

The user name you are currently logged in with. If this value is not available, you will see the text: unable to retrieve user-id.

Windows system directory

Displays where Windows itself is located.

Current directory

The drive and full path of the current directory.

Filelist

The full path and name of the file currently being used as the DataFlex file list.

Available Memory

Amount of free memory. This information will not be displayed in Windows/NT because it is retrieved with 16-bit DLL calls.

Video Resolution

The number of pixels provided in the screen display horizontally and vertically.

Pageend

The value currently stored in the pageend global variable of the Visual DataFlex runtime.

Formfeed

The value currently stored in the formfeed global variable of the Visual DataFlex runtime.

Thousands Seperator

The thousands’ separator character.

Decimal Seperator

The decimal (radix) character.

Date Format

The date format. This can be USA (month/day/year), European (day/month/year), or military (year.month.day).

Lock Delay

Shows the delay time, in milliseconds, between lock attempts (DF_LOCK_DELAY).

Lock timeout

Shows the time, in milliseconds, after which an ungranted lock will be considered an error (DF_LOCK_TIMEOUT).

Current System Date and Time

The current system date and time are shown.

GDI

Amount of free GDI (Graphical Display Interpreter) memory. This information will not display in Windows/NT because it is retrieved with 16-bit DLL calls.

User

Amount of free user space. This information will not display in Windows/NT because it is retrieved with 16-bit DLL calls.

System

Amount of free system space. This information will not display in Windows/NT because it is retrieved with 16-bit DLL calls.

Close

This button will close the System Information panel.


Flexerrs_Maintenance_Overview

Error Code Maintenance

With the Error Code Maintenance program, you can browse through the list of error files of any environment or workspace and open the files to inspect/change data.

When the dbAdminMode key of the registry is ON or DDB, the Error Code Maintenance program allows you to open all error files and examine and/or edit its data. The error numbers lower than 120 and higher than 4096 cannot be deleted. Only the text can be changed. If the dbAdminmode key is not set to ON or DDB, new records cannot be added to the user errors section.

For detailed information on various error messages and how to resolve them, go to the Error Codes help book.